/*******************************************************************************
 * Apache License, Version 2.0 (http://www.apache.org/licenses/LICENSE-2.0)
 * Copyright (c) 2011- kotemaru@kotemaru.org
 ******************************************************************************/
// WARN!! Do not edit this file.
package org.kotemaru.wsjs;

import java.io.* ;
import java.net.* ;
import java.util.* ;
import org.mozilla.javascript.*;
import org.kotemaru.util.* ;
import org.kotemaru.auth.* ;
import javax.servlet.*;
import javax.servlet.http.*;


/**
 * 設定情報のBean。<ul>
 * <li>ConfigBean.bean からの生成ファイルなので ConfigBean.java を修正してはならない。
 * </ul>
 */
public abstract class ConfigBean implements Serializable
/*extends ScriptableObject*/ {
	protected static Config INSTANCE;

	protected  String saveConfigFile;
	protected  boolean isGAE = true;
	protected  String documentRoot = "webapps";
	protected  String databaseRoot = "database";
	protected  String[] directoryIndex = {"index.html","index.wiki"};
	protected  boolean enableDirectoryList = true;
	protected  int expires = 0;
	protected  Processor[] processors;
	protected  String encoding = "UTF-8";

	protected  int limitTotalCacheSize = 100000000;
	protected  int limitProcCacheSize = 50000;

	protected  String proxyHost = null;
	protected  int proxyPort = 0;

	protected  String[][] permitRead = null;
	protected  String[][] permitWrite = null;
	protected  String[][] permitClass = null;
	protected  String[][] permitJNDI  = null;


	protected  Scriptable extensions;
	protected  PAM pam = null;
	protected  RoleManager roleManager = null;
	protected  UserManager userManager = null;
	protected  int logLeval = 0;
                                   
                                   
	// ScriptableObject methods.
	protected transient Scriptable __scope;
	public ConfigBean(){
	}
	public ConfigBean(Scriptable scope){
		this.__scope = scope;
	}
	public void jsConstructor() {
	}
	public String getClassName() {
		return "Config";
	}
	public java.util.Iterator __iterator__(boolean b){
		return iterator();
	}
	public JavaScriptException __getStopIteratin() {
		return new JavaScriptException(
			NativeIterator.getStopIterationObject(__scope), null, 0);
	}

	private static final String[] NAMES = {
"saveConfigFile",
"isGAE",
"documentRoot",
"databaseRoot",
"directoryIndex",
"enableDirectoryList",
"expires",
"processors",
"encoding",
"limitTotalCacheSize",
"limitProcCacheSize",
"proxyHost",
"proxyPort",
"permitRead",
"permitWrite",
"permitClass",
"permitJNDI",
"extensions",
"pam",
"roleManager",
"userManager",
"logLeval",
};
	public java.util.Iterator iterator(){
		return new MyIterator(NAMES);
	}
	private  class MyIterator implements java.util.Iterator {
		private Object[] array;
		private int idx = 0;
		public MyIterator(Object[] ary) {array = ary;}
		public boolean hasNext(){return idx<array.length;}
		public Object next(){
			if (idx>=array.length) throw __getStopIteratin();
			return array[idx++];
		}
		public void remove(){throw new Error("Unsupport");}
	}


	// Java Accessors
    public static void setSaveConfigFile(String pSaveConfigFile) {
        INSTANCE.saveConfigFile = pSaveConfigFile;
    }
    public static String getSaveConfigFile() {
        return INSTANCE.saveConfigFile;
    }
    public static void setIsGAE(boolean pIsGAE) {
        INSTANCE.isGAE = pIsGAE;
    }
    public static boolean getIsGAE() {
        return INSTANCE.isGAE;
    }
    public static void setDocumentRoot(String pDocumentRoot) {
        INSTANCE.documentRoot = pDocumentRoot;
    }
    public static String getDocumentRoot() {
        return INSTANCE.documentRoot;
    }
    public static void setDatabaseRoot(String pDatabaseRoot) {
        INSTANCE.databaseRoot = pDatabaseRoot;
    }
    public static String getDatabaseRoot() {
        return INSTANCE.databaseRoot;
    }
    public static void setDirectoryIndex(String[] pDirectoryIndex) {
        INSTANCE.directoryIndex = pDirectoryIndex;
    }
    public static String[] getDirectoryIndex() {
        return INSTANCE.directoryIndex;
    }
    public static void setEnableDirectoryList(boolean pEnableDirectoryList) {
        INSTANCE.enableDirectoryList = pEnableDirectoryList;
    }
    public static boolean getEnableDirectoryList() {
        return INSTANCE.enableDirectoryList;
    }
    public static void setExpires(int pExpires) {
        INSTANCE.expires = pExpires;
    }
    public static int getExpires() {
        return INSTANCE.expires;
    }
    public static void setProcessors(Processor[] pProcessors) {
        INSTANCE.processors = pProcessors;
    }
    public static Processor[] getProcessors() {
        return INSTANCE.processors;
    }
    public static void setEncoding(String pEncoding) {
        INSTANCE.encoding = pEncoding;
    }
    public static String getEncoding() {
        return INSTANCE.encoding;
    }
    public static void setLimitTotalCacheSize(int pLimitTotalCacheSize) {
        INSTANCE.limitTotalCacheSize = pLimitTotalCacheSize;
    }
    public static int getLimitTotalCacheSize() {
        return INSTANCE.limitTotalCacheSize;
    }
    public static void setLimitProcCacheSize(int pLimitProcCacheSize) {
        INSTANCE.limitProcCacheSize = pLimitProcCacheSize;
    }
    public static int getLimitProcCacheSize() {
        return INSTANCE.limitProcCacheSize;
    }
    public static void setProxyHost(String pProxyHost) {
        INSTANCE.proxyHost = pProxyHost;
    }
    public static String getProxyHost() {
        return INSTANCE.proxyHost;
    }
    public static void setProxyPort(int pProxyPort) {
        INSTANCE.proxyPort = pProxyPort;
    }
    public static int getProxyPort() {
        return INSTANCE.proxyPort;
    }
    public static void setPermitRead(String[][] pPermitRead) {
        INSTANCE.permitRead = pPermitRead;
    }
    public static String[][] getPermitRead() {
        return INSTANCE.permitRead;
    }
    public static void setPermitWrite(String[][] pPermitWrite) {
        INSTANCE.permitWrite = pPermitWrite;
    }
    public static String[][] getPermitWrite() {
        return INSTANCE.permitWrite;
    }
    public static void setPermitClass(String[][] pPermitClass) {
        INSTANCE.permitClass = pPermitClass;
    }
    public static String[][] getPermitClass() {
        return INSTANCE.permitClass;
    }
    public static void setPermitJNDI(String[][] pPermitJNDI) {
        INSTANCE.permitJNDI = pPermitJNDI;
    }
    public static String[][] getPermitJNDI() {
        return INSTANCE.permitJNDI;
    }
    public  void setExtensions(Scriptable pExtensions) {
        extensions = pExtensions;
    }
    public  Scriptable getExtensions() {
        return extensions;
    }
    public static void setPam(PAM pPam) {
        INSTANCE.pam = pPam;
    }
    public static PAM getPam() {
        return INSTANCE.pam;
    }
    public static void setRoleManager(RoleManager pRoleManager) {
        INSTANCE.roleManager = pRoleManager;
    }
    public static RoleManager getRoleManager() {
        return INSTANCE.roleManager;
    }
    public static void setUserManager(UserManager pUserManager) {
        INSTANCE.userManager = pUserManager;
    }
    public static UserManager getUserManager() {
        return INSTANCE.userManager;
    }
    public  void setLogLeval(int pLogLeval) {
        logLeval = pLogLeval;
    }
    public  int getLogLeval() {
        return logLeval;
    }


}
